//
//  Game_Object.h
//  Application
//
//  Created by Stephen Brown on 9/20/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#ifndef GAME_OBJECT
#define GAME_OBJECT

#include<zenilib.h>

using namespace std;
using namespace Zeni;


class Game_Object {
public:
  Point2f m_position; //Upper left corner
  Vector2f m_size; // (width, height)
  float m_theta;
  float m_speed;
  
  Game_Object();
  
  Game_Object(const Point2f &position_, const Vector2f &size_, const float &theta_ = 0.0f, const float &speed_ = 0.0f);
  
  // If you might delete base class pointers, you need a virtual destructor.
  virtual ~Game_Object() {}
  
  virtual void render() const = 0; //pure virtual function call
  
  void turn_left(const float &theta_);
  
  void move_forward(const float &move_);
  
  
  //BULLET STUFF
  const Point2f & get_position() const;
  const Vector2f & get_size() const;
  const float & get_theta() const;
  
  const float get_radius() const;
  
  //COLLISION DETECTION
  virtual bool collide(const Game_Object & rhs) const;
  
protected:
  void render(const String &texture, const Color &filter = Color()) const;
};

#endif
