//
//  Level.h
//  Application
//
//  Created by Stephen Brown on 9/20/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#ifndef LEVEL
#define LEVEL

#include <zenilib.h>
#include "Track.h"
#include "Train.h"a

using namespace Zeni;




class Level{
private:
  Point2f centerPoint;
  Point2f bounds_upperLeft;
  Point2f bounds_lowerRight;
  
  
public:
  int levelNumber;
  Train* playerTrain;
  int numTracks;
  int numTrackPieces;
  Track tracks[10];
  list<Parked_Car *> parkedCars;
  list<Parked_Car *> waitingParkedCars;
  list<AI_Train *> AITrains;
  list<AI_Train *> waitingAITrains;
  float levelEnd;
  float lastX[30];
  
  Level(const int & levelNum);
  void addNewParkedCar(const int track_Number_, const float xCoord_, const float v_0, Car_Type type_, const float timeTrigger_, float offset);
  void addNewAITrain(const int trackNumber_, const float yCoord_, const float v_0, vector<Car> & cars, float timeTrigger_, float offset);
  void filterAITrains();
  void filterParkedCars();
  
  template<typename T>
  void triggerStuff(list<T*> & waitingStuff, list<T* > & activeStuff, float time, bool* alerts);
  void triggerForX(const float X);
  void triggerForTime(const float time, bool* alerts);
  void moveCenter(Point2f newPoint);
  ~Level();
  
  virtual  void render() const;
  
  
};

Car_Type stringToEnum(char* string);

#endif
